using System;

namespace ERModel
{
	/// <summary>
	/// Summary description for ERForeignKey.
	/// </summary>
	public class ERForeignKey:ERElement
	{
		private string _referenceTable;
		private string _referenceSchema;
		private string _referencedTable;
		private string _referencedSchema;
		private string[] _columns;
		private string[] _refColumns;
		private string _onUpdate;
		private string _onDelete;

		public ERForeignKey(ERModel model):base(model)
		{
		}

		public string[] Columns
		{
			get { return _columns;}
			set {_columns = value;}
		}

		public string[] RefColumns
		{
			get {return _refColumns;}
			set {_refColumns = value;}
		}

		public string ReferencedTable
		{
			get { return _referencedTable; }
			set { _referencedTable = value;}
		}

		public string ReferenceTable
		{
			get { return _referenceTable; }
			set { _referenceTable = value;}
		}

		public string ReferencedSchema
		{
			get { return _referencedSchema; }
			set { _referencedSchema = value;}
		}

		public string ReferenceSchema
		{
			get { return _referenceSchema; }
			set { _referenceSchema = value;}
		}

		public string OnUpdate
		{
			get { return _onUpdate; }
			set { _onUpdate = value;}
		}

		public string OnDelete
		{
			get { return _onDelete; }
			set { _onDelete = value;}
		}
	}
}
