using System;

namespace ERModel
{
	/// <summary>
	/// Summary description for ERModel.
	/// </summary>
	public class ERModel
	{
		public const int QUOTE_SQL_AUTO = 1;
		public const int QUOTE_SQL_YES = 2;
		public const int QUOTE_SQL_NO = 3;

		private int _quoteSQLIdentifier;
		private System.Collections.IList _elements;

		public ERModel()
		{
			_elements = new System.Collections.ArrayList();
		}

		public void setQuoteSQLIdentifier(int value) 
		{
			_quoteSQLIdentifier = value;
		}

		public int getQuoteSQLIdentifier() 
		{
			return _quoteSQLIdentifier;
		}

		public System.Collections.IList Elements
		{
			get {return _elements;}
		}

		public void addElement(ERElement element)
		{
			_elements.Add(element);
		}

		public EREntity getEntityByName(String entityName)
		{
			EREntity result = null;
			foreach(ERElement element in _elements)
			{
				if(element.GetName().Equals(entityName))
				{
					result = element as EREntity;
					break;
				}
			}
			return result;
		}

		public ERColumn GetColumnByFullName(string columnFullName)
		{
			ERColumn result = null;
			int index = columnFullName.IndexOf('.');
			if(index > 0)
			{
				EREntity entity = getEntityByName(columnFullName.Substring(0, index));
				if(entity != null)
				{
					result = entity.GetColumnByName(columnFullName.Substring(index+1));
				}
			}
			return result;
		}
	}
}
