using System;
using System.Collections;
using System.Text;
using System.Xml;

namespace ERModel.Handler
{
    public class ERTriggerHandler
    {
        public ERTriggerHandler()
        {
        }

        public ERTrigger ReadERElement(ERModel model, XmlNode xmlNode)
        {
            ERTrigger trigger = new ERTrigger(model);
            trigger.SetName(xmlNode.Attributes["name"].Value);
            XmlElement contentNode = null;

            foreach (XmlNode childNode in xmlNode.ChildNodes)
            {
                if (childNode is XmlElement)
                {
                    if ("CreateStmt".Equals(childNode.Name))
                    {
                        contentNode = (XmlElement)childNode;
                        break;
                    }
                }
            }

            if (contentNode != null)
            {
                trigger.Statements = contentNode.InnerText;
            }

            return trigger;
        }
        
    }
}
