using System;
using System.Collections;
using System.Xml;
using System.IO;
using NHibernate.Dialect;

namespace ERToDB.Configuration
{
	/// <summary>
	/// Summary description for HibernateProperties.
	/// </summary>
	public class HibernateProperties
	{
		public HibernateProperties()
		{
		}

		public IDictionary LoadProperties(string fileName)
		{
			XmlDocument xmlDoc = new XmlDocument();
			xmlDoc.Load(fileName);
			return ParseDocuement(xmlDoc);
		}

		private IDictionary ParseDocuement(XmlDocument xmlDoc)
		{
			IDictionary properties = new Hashtable();
			XmlNamespaceManager cfgNamespaceMgr = new XmlNamespaceManager( xmlDoc.NameTable );
			cfgNamespaceMgr.AddNamespace("cfg", "urn:nhibernate-configuration-2.0");
			XmlNode node = xmlDoc.DocumentElement.SelectSingleNode( "//" + "cfg" + ":session-factory", cfgNamespaceMgr );
			XmlNodeList propList =  node.SelectNodes("//" + "cfg" + ":property", cfgNamespaceMgr);
			foreach(XmlNode propNode in propList)
			{
				properties.Add(propNode.Attributes["name"].Value, propNode.InnerText);
			}
			return properties;
		}
	}
}
