using System;
using System.Data;
using System.Collections;
using NHibernate.Dialect;

namespace ERToDB.DataSet
{
	/// <summary>
	/// Summary description for DataSetUtil.
	/// </summary>
	public class DataSetUtil
	{
		private readonly IList sequences = new ArrayList();
		private IDbConnection _conn;
		private Dialect _dialect;
		public DataSetUtil(IDbConnection conn, Dialect dialect)
		{
			_dialect = dialect;
			_conn = conn;
//			InitSequences(conn, dialect);
		}

		public DataTable GetDataTable(IDbConnection conn, string schema, string tableName, Dialect dialect, ERModel.ERModel model)
		{
			IDbCommand command = conn.CreateCommand();
			command.CommandText = "SELECT * FROM " + DDLGeneratorUtil.GetQualifiedName(schema, tableName, dialect, model.getQuoteSQLIdentifier());
			try
			{
				IDataReader dr = command.ExecuteReader();
				DataTable dataTable = dr.GetSchemaTable();
				Console.WriteLine( dataTable.ExtendedProperties.Count);
				Console.WriteLine("*******************************************");
				Console.WriteLine("constraints : " + dataTable.Constraints.Count);
				Console.WriteLine("Parent relation : " + dataTable.ParentRelations.Count);
				Console.WriteLine("child relation : "  + dataTable.ChildRelations.Count);
				Console.WriteLine("*******************************************");
//				foreach (DataRow myField in dataTable.Rows)
//				{
//					//For each property of the field...
//					foreach (DataColumn myProperty in dataTable.Columns) 
//					{
//						//Display the field name and value.
//						Console.WriteLine(myProperty.ColumnName + " = " + myField[myProperty].ToString());
//					}
//					Console.WriteLine();
//
//					//Pause.
//					Console.ReadLine();
//				}
				dr.Close();
				return dataTable;
			}
			catch(Exception e)
			{
				Console.WriteLine(e.Message +  e.StackTrace);
				return null;
			}
		}

//		private void InitSequences(IDbConnection conn, Dialect dialect)
//		{
//			string sql = dialect.QuerySequenceString;
//
//			if (sql == null)
//			return;
//			try 
//			{
//				IDbCommand command =  conn.CreateCommand();
//				command.CommandText = sql;
//				IDataReader dr = command.ExecuteReader();
//				sequences.Add(dr[1].ToString().ToUpper());
//
//			} 
//			catch(Exception)
//			{
//			}
//		}

		public bool IsSequence(object key) 
		{
			return key is string && sequences.Contains(((string) key).ToUpper());
		}

		public bool IsTable(object key, ERModel.ERModel model)
		{
			return key is String && (GetDataTable(_conn, null, (string) key, _dialect, model) != null);
		}
	}
}
