using System;
using System.Collections;
using System.Text;
using ERModel;

namespace ERToDB.Decorators
{
    public class MSSQLDecorator : StandardDecorator
    {
        public override string[] DecorateCreateSQL(ERModel.ERProcedure[] aProcedures, NHibernate.Dialect.Dialect aDialect, int aQuoteSQL)
        {
            ArrayList result = new ArrayList(aProcedures.Length*2);
            for (int i = 0; i < aProcedures.Length; i++)
            {
                ERProcedure procedure = aProcedures[i];
                result.Add("DROP PROCEDURE " + procedure.GetName());
                result.Add(procedure.Statements);
            }
            return (string[]) result.ToArray(typeof(string));
        }

        public override string[] DecorateCreateSQL(ERTrigger[] aTriggers, NHibernate.Dialect.Dialect aDialect, int aQuoteSQL)
        {
            ArrayList result = new ArrayList(aTriggers.Length * 2);
            for (int i = 0; i < aTriggers.Length; i++)
            {
                ERTrigger trigger = aTriggers[i];
                result.Add("DROP TRIGGER " + trigger.GetName());
                result.Add(trigger.Statements);
            }
            return (string[])result.ToArray(typeof(string));
        }
    }
}
