using System;
using System.Collections;
using System.Text;
using System.Text.RegularExpressions;

namespace ERToDB.Decorators
{
    public class OracleDecorator : StandardDecorator
    {

        public override string[] DecorateCreateSQL(ERModel.ERProcedure[] aProcedures, NHibernate.Dialect.Dialect aDialect, int aQuoteSQL)
        {
            ArrayList result = new ArrayList();
            for (int i = 0; i < aProcedures.Length; i++)
            {
                ERModel.ERProcedure procedure = aProcedures[i];
                result.Add(ToCreateOrReplaceStatement(procedure.Statements));
            }
            return (string[])result.ToArray(typeof(string));
        }

        public override string[] DecorateCreateSQL(ERModel.ERTrigger[] aTriggers, NHibernate.Dialect.Dialect aDialect, int aQuoteSQL)
        {
            ArrayList result = new ArrayList();
            for (int i = 0; i < aTriggers.Length; i++)
            {
                ERModel.ERTrigger trigger = aTriggers[i];
                result.Add(ToCreateOrReplaceStatement(trigger.Statements));
            }
            return (string[])result.ToArray(typeof(string));
        }

        public static string ToCreateOrReplaceStatement(string aStatement)
        {
            if (aStatement!=null) {
                Match matcher = Regex.Match(aStatement, "create\\s+or\\s+replace", RegexOptions.IgnoreCase);
                if (matcher.Success) {
                    int index = aStatement.ToLower().IndexOf("create");
                    return "CREATE OR REPLACE"+aStatement.Substring(index+6);
                }
            }
            return aStatement;
        }
    }
}
