using System;
using NHibernate.Dialect;
using Ormtypemapper;
using System.Runtime.CompilerServices;

namespace ERToDB
{
	/// <summary>
	/// Summary description for DialectDBTypeMapper.
	/// </summary>
	public class DialectDBTypeMapper
	{
		private static DialectDBTypeMapper _instance;
		private System.Collections.IDictionary _dialectDBMap;

		public DialectDBTypeMapper()
		{
			_dialectDBMap = new System.Collections.Hashtable();
			_dialectDBMap.Add(typeof(PostgreSQLDialect).Name, DBType.DBTYPE_POSTGRESQL);
			_dialectDBMap.Add(typeof(MsSql2000Dialect).Name, DBType.DBTYPE_MS_SQL);
			_dialectDBMap.Add(typeof(MySQLDialect).Name, DBType.DBTYPE_MY_SQL);
            _dialectDBMap.Add(typeof(MySQLInnoDBDialect).Name, DBType.DBTYPE_MY_SQL);
            _dialectDBMap.Add(typeof(MySQLMyISAMDialect).Name, DBType.DBTYPE_MY_SQL);
			_dialectDBMap.Add(typeof(MsSql7Dialect).Name, DBType.DBTYPE_MS_SQL);
			_dialectDBMap.Add(typeof(Oracle9Dialect).Name, DBType.DBTYPE_ORACLE);
			_dialectDBMap.Add(typeof(OracleDialect).Name, DBType.DBTYPE_ORACLE);
			_dialectDBMap.Add(typeof(DB2Dialect).Name, DBType.DBTYPE_DB2);
			_dialectDBMap.Add(typeof(GenericDialect).Name, DBType.DBTYPE_INFORMIX);
            _dialectDBMap.Add(typeof(Cache71Dialect).Name, DBType.DBTYPE_CACHE);
            _dialectDBMap.Add(typeof(SQLiteDialect).Name, DBType.DBTYPE_SQLITE);
		}
		
		[MethodImpl(MethodImplOptions.Synchronized)]
		public static DialectDBTypeMapper Instance()
		{
			if(_instance == null)
			{
				_instance = new DialectDBTypeMapper();
			}
			return _instance;
		}

		public int GetDBType(string dialect)
		{
			return (int)_dialectDBMap[dialect];
		}
	}
}
