using System;

namespace ERToDB
{
	/// <summary>
	/// Summary description for SQLReservedWordChecker.
	/// </summary>
	public class SQLReservedWordChecker
	{
		private static SQLReservedWordChecker _checker = null;

		private SQLReservedWordChecker() 
		{
		}

		public static SQLReservedWordChecker getInstance() 
		{
			if (_checker == null)
				_checker = new SQLReservedWordChecker();
			return _checker;
		}

		public bool isReservedWord(String s) 
		{
			for (int i = 0; i < reservedWords.Length; i++) 
			{
				if (s.ToLower().Equals(reservedWords[i]))
					return true;
			}
    	
			return false;
		}

		private readonly string[] reservedWords = new string[] {
			"add", "all", "alter", "and", "as", "asc", "between",
			"binary", "by", "column", "constraint", "create", "database", "delete", "desc",
			"distinct", "drop", "exists", "foreign", "from", "fulltext", "group", "having", "ignore", "in",
			"index", "inner", "insert", "into", "is", "join", "key", "left", "like", "not", "null",
			"or", "order", "procedure", "primary", "outer", "right", "select", "set", "table",
			"union", "unique", "update", "values", "view", "where", "with", "xor" };
	}
}
