using System;
using System.Collections;
using NHibernate.SqlCommand;
using NHibernate;
#if NET_2_0
using System.Collections.Generic;
#endif

namespace Orm.Criteria
{
	public abstract class AbstractORMCriteria : ICriteria
	{
		private readonly ICriteria _criteria;

		public AbstractORMCriteria(ICriteria aCriteria) 
		{
			this._criteria = aCriteria;
		}
		#region ICriteria Members

		public string Alias { 
			get { return _criteria.Alias; } 
		}

		public ICriteria SetMaxResults(int maxResults)
		{
			return _criteria.SetMaxResults(maxResults);
		}

		public ICriteria SetFirstResult(int firstResult)
		{
			return _criteria.SetFirstResult(firstResult);
		}

		public ICriteria SetTimeout(int timeout)
		{
			return _criteria.SetTimeout(timeout);
		}

		public ICriteria Add(NHibernate.Expression.ICriterion expression)
		{
			return _criteria.Add(expression);
		}

		public ICriteria AddOrder(NHibernate.Expression.Order order)
		{
			return _criteria.AddOrder(order);
		}

		public System.Collections.IList List()
		{
			return _criteria.List();
		}

		public void List(IList results) 
		{
			_criteria.List(results);
		}

#if NET_2_0
		public IList<T> List<T>() {
			return _criteria.List<T>();
		}

		public T UniqueResult<T>() {
			return _criteria.UniqueResult<T>();
		}
#endif

		public ICriteria SetFetchMode(string associationPath, NHibernate.FetchMode mode)
		{
			return _criteria.SetFetchMode(associationPath, mode);
		}

		public ICriteria SetLockMode(LockMode lockMode)
		{
			return _criteria.SetLockMode(lockMode);
		}

		ICriteria NHibernate.ICriteria.SetLockMode(string alias, LockMode lockMode)
		{
			return _criteria.SetLockMode(alias, lockMode);
		}

		public object UniqueResult()
		{
			return _criteria.UniqueResult();
		}

		public ICriteria CreateAlias(string associationPath, string alias)
		{
			return _criteria.CreateAlias(associationPath, alias);
		}

		public ICriteria CreateAlias(string associationPath, string alias, JoinType joinType)
		{
			return _criteria.CreateAlias(associationPath, alias, joinType);
		}

		public ICriteria CreateCriteria(string associationPath)
		{
			return _criteria.CreateCriteria(associationPath);
		}

		ICriteria NHibernate.ICriteria.CreateCriteria(string associationPath, string alias)
		{
			return _criteria.CreateCriteria(associationPath, alias);
		}

		public ICriteria CreateCriteria(string associationPath, string alias, JoinType joinType)
		{
			return _criteria.CreateCriteria(associationPath, alias, joinType);
		}

		public ICriteria CreateCriteria(string associationPath, JoinType joinType) 
		{
			return _criteria.CreateCriteria(associationPath, joinType);
		}

		public ICriteria SetResultTransformer(NHibernate.Transform.IResultTransformer resultTransformer)
		{
			return _criteria.SetResultTransformer(resultTransformer);
		}

		public ICriteria SetCacheable(bool cacheable)
		{
			return _criteria.SetCacheable(cacheable);
		}

		public ICriteria SetCacheRegion(string cacheRegion)
		{
			return _criteria.SetCacheRegion(cacheRegion);
		}

		public ICriteria SetProjection(NHibernate.Expression.IProjection projection) 
		{
			return _criteria.SetProjection(projection);
		}

		#endregion
	}
}
