using System;
using NHibernate;

namespace Orm.Criteria
{
	public class AbstractORMExpression 
	{
		private readonly ICriteria _criteria;
		private readonly String _propName;

		public AbstractORMExpression(String aName, ICriteria aCriteria) 
		{
			this._propName = aName;
			this._criteria = aCriteria;
		}
	
		protected String PropName 
		{
			get 
			{
				return _propName;
			}
		}

		protected void AddCriteria(NHibernate.Expression.ICriterion aCriterion) 
		{
			_criteria.Add(aCriterion);
		}

        public void IsEmpty()
        {
            AddCriteria(NHibernate.Expression.Expression.IsEmpty(PropName));
        }

        public void IsNotEmpty()
        {
            AddCriteria(NHibernate.Expression.Expression.IsNotEmpty(PropName));
        }

        public void IsNull() 
		{
			AddCriteria(NHibernate.Expression.Expression.IsNull(PropName));
		}

    	public void IsNotNull() 
		{
			AddCriteria(NHibernate.Expression.Expression.IsNotNull(PropName));
		}
	
		public void Order(bool aAscending) 
		{
			NHibernate.Expression.Order lOrder;
			if (aAscending) 
			{
				lOrder = NHibernate.Expression.Order.Asc(_propName);
			} 
			else 
			{
				lOrder = NHibernate.Expression.Order.Desc(_propName);
			}
			_criteria.AddOrder(lOrder);
		}
	}
}
