using System;
using NHibernate;

namespace Orm.Criteria 
{
	public class DecimalExpression : AbstractORMExpression 
	{
		public DecimalExpression(string aName, ICriteria aCriteria) : base(aName, aCriteria) 
		{
		}

		public void Eq(Decimal aValue) 
		{
			AddCriteria(NHibernate.Expression.Expression.Eq(PropName, aValue));
		}

		public void Gt(Decimal aValue) 
		{
			AddCriteria(NHibernate.Expression.Expression.Gt(PropName, aValue));
		}

		public void Ge(Decimal aValue) 
		{
			AddCriteria(NHibernate.Expression.Expression.Ge(PropName, aValue));
		}

		public void Lt(Decimal aValue) 
		{
			AddCriteria(NHibernate.Expression.Expression.Lt(PropName, aValue));
		}

		public void Between(Decimal aValue1, Decimal aValue2) 
		{
			AddCriteria(NHibernate.Expression.Expression.Between(PropName, aValue1, aValue2));
		}

		public void In(Decimal[] aValues) 
		{
			AddCriteria(NHibernate.Expression.Expression.In(PropName, aValues));
		}

	}
}