using System;
using System.Reflection;
using NHibernate;
using NHibernate.Cfg;
using NHibernate.Tool.hbm2ddl;
using ERModel;
using ERModel.Handler;
using ERToDB;
using NHibernate.Dialect;

namespace Orm
{
	public class ORMDatabaseInitiator
	{
		public static void CreateSchema(PersistentManager persistentManager)
		{
			try
			{
				ERModel.ERModel model = LoadERModel(persistentManager);
				DDLGenerator ddlGenerator = new DDLGenerator();
				ddlGenerator.createSchema(model, persistentManager.GetCfg.Properties, null, true);
			}
			catch(HibernateException e)
			{
				throw new PersistentException(e);
			}
		}

		public static void DropSchema(PersistentManager persistentManager)
		{
			try
			{
				ERModel.ERModel model = LoadERModel(persistentManager);
				DDLGenerator ddlGenerator = new DDLGenerator();
				ddlGenerator.DropSchema(model, persistentManager.GetCfg.Properties, null, true);
//				SchemaExport schemaExport = new SchemaExport(cfg);
//				schemaExport.Drop(true, true);

			}
			catch(HibernateException e)
			{
				throw new PersistentException(e);
			}
		}

		public static void UpdataSchema(PersistentManager persistentManager)
		{
			try
			{
				ERModel.ERModel model = LoadERModel(persistentManager);
				DDLGenerator ddlGenerator = new DDLGenerator();

				Configuration cfg = new Configuration();
				cfg.Configure();
				ddlGenerator.UpdateSchema(model, cfg.BuildSessionFactory().OpenSession().Connection, cfg.Properties, null, true);
			}
			catch(HibernateException e)
			{
				throw new PersistentException(e);
			}
		}

		private static ERModel.ERModel LoadERModel(PersistentManager aPersistentManager) 
		{
			ERModelHandler lModelHandler = new ERModelHandler();
			Assembly assembly = aPersistentManager.GetAssembly();
			// Assume default namespace = assembly name
			ERModel.ERModel lModel = lModelHandler.Load(assembly, assembly.FullName + ".ormmapping." + aPersistentManager.GetProjectName() + ".erd.xml");
			if (lModel == null) 
			{
				lModel = lModelHandler.Load("../../ormmapping/" + aPersistentManager.GetProjectName() + ".erd.xml");
			}
			return lModel;
		}

		public static ERModel.ERModel LoadERModel(String filePath)
		{
			ERModelHandler lModelHandler = new ERModelHandler();
			ERModel.ERModel lModel = lModelHandler.Load(filePath);
			return lModel;
		}
	}
}
