using System;
using NHibernate.Dialect;

namespace Orm.Util
{
	public class DDLGeneratorUtil
	{
		public DDLGeneratorUtil()
		{
		}

		public static string GetIDGeneratorKey(string schema, string tableName, string columnName, string idGenerator, string idGeneratorKey, 
			Dialect dialect, bool aTableQuote, bool aColumnQuote)
		{
			if(idGeneratorKey != null && idGeneratorKey.Length > 0)
			{
				return idGeneratorKey;
			}

			string prefix = "";
			if (schema != null && schema.Length > 0) 
			{
				prefix = schema + ".";
			}
			
			if(idGenerator.Equals(ERModelConstants.IDG_SEQUENCE) || idGenerator.Equals(ERModelConstants.IDG_SEQ_HILO))
			{
				if(dialect is PostgreSQLDialect)
				{
					String lTableName = tableName;
					String lColumnName = columnName;
					if(!aTableQuote)
					{
						lTableName = lTableName.ToLower();
					}

					if(!aColumnQuote)
					{
						lColumnName = lColumnName.ToLower();
					}
					return prefix + "\"" + lTableName.Replace(" ", "_") + "_" + lColumnName + "_seq\"";
				}
				return prefix + "seq_" + tableName.Replace(" ", "_");
			}
			else if(idGenerator.Equals(ERModelConstants.IDG_HILO))
			{
				return prefix + "id_" + tableName.Replace(" ", "_"); 
			}
			return null;
		}

		
		public static string GETIDGererator(String strategy, Dialect dialect, bool isInt)
		{
			if(strategy.Equals(ERModelConstants.IDG_NATIVE))
			{
				if(isInt)
				{
					if(dialect.SupportsIdentityColumns)
					{
						return ERModelConstants.IDG_IDENTITY;
					}
					else if(dialect.SupportsSequences)
					{
						return ERModelConstants.IDG_SEQUENCE;
					}
					else
					{
						return ERModelConstants.IDG_HILO;
					}
				}
				else 
				{
					return ERModelConstants.IDG_ASSIGNED;
				}
			}
			return strategy;
		}
	}
}
